const _Http = getApp().globalData.http;
Page({
    data: {
        ownerid: null,
        ownertable: null,
        sys_datafollowupid: 0,
        type: "",
        content: "",
        actions: [{
            name: "上门拜访"
        }, {
            name: "电话拜访"
        }, {
            name: "微信联系"
        }, {
            name: "QQ联系"
        }],
        show: false
    },
    onLoad(options) {
        if (options.ownertable) {
            this.setData({
                ...options
            })
        }
    },
    openSelect() {
        this.setData({
            show: true
        })
    },
    onCancel() {
        this.setData({
            show: false
        })
    },
    onSelect({
        detail
    }) {
        this.setData({
            type: detail.name
        })
        this.onCancel();
    },
    onInput(e) {
        this.setData({
            content: e.detail.value
        })
    },
    selectUser() {
        wx.navigateTo({
            url: `/packageA/group/index?ownertable=${this.data.ownertable}&ownerid=${this.data.ownerid}&radio`,
        })
    },
    submit() {
        const content = {
            type: this.data.type,
            content: this.data.content,
            ownerid: this.data.ownerid,
            ownertable: this.data.ownertable,
            sys_datafollowupid: this.data.sys_datafollowupid
        };
        if (!content.content) return;
        _Http.basic({
            "id": 20220930121601,
            content
        }).then(res => {
            console.log("新增或编辑", res)
            if (res.msg != '成功') return wx.showToast({
                title: res.data,
                icon: "none"
            });
            wx.showToast({
                title: '保存成功',
                icon: "none"
            });
            setTimeout(() => {
                getCurrentPages().forEach(v => {
                    switch (v.__route__) {
                        //详情界面更新数据
                        case 'packageA/setclient/modules/trace/detail/index':
                            v.getDetail();
                            break;
                            //列表页更新数据
                        case 'packageA/setclient/detail':
                            let page = v.selectComponent("#Trace"),
                                list = page.data.list,
                                index = list.findIndex(value => value.sys_datafollowupid == res.data.sys_datafollowupid);
                            if (index != -1) {
                                //列表中存在说明是编辑，返回上一级页面并更新数据
                                list[index] = res.data;
                                page.setData({
                                    list
                                });
                                wx.navigateBack();
                            } else {
                                //列表中不存在说明是新增，返回上一级页面更新数据 并进入详情
                                list.push(res.data);
                                page.setData({
                                    list,
                                    "content.total": page.data.content.total + 1
                                });
                                wx.navigateBack();
                                wx.navigateTo({
                                    url: `/packageA/setclient/modules/trace/detail/index?data=` + JSON.stringify({
                                        "sys_datafollowupid": res.data.sys_datafollowupid,
                                        "ownertable": this.data.ownertable,
                                        "ownerid": this.data.ownerid
                                    }),
                                })
                            }
                            break;
                    }
                });
            }, 300)
        })
    },
})